/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;

import com.proliferay.servicebuilder.service.BlobDemoLocalServiceUtil;
import com.proliferay.servicebuilder.service.ClpSerializer;

import java.io.Serializable;

import java.lang.reflect.Method;

import java.sql.Blob;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Hamidul Islam
 */
public class BlobDemoClp extends BaseModelImpl<BlobDemo> implements BlobDemo {
	public BlobDemoClp() {
	}

	@Override
	public Class<?> getModelClass() {
		return BlobDemo.class;
	}

	@Override
	public String getModelClassName() {
		return BlobDemo.class.getName();
	}

	@Override
	public long getPrimaryKey() {
		return _blobId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setBlobId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _blobId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("blobId", getBlobId());
		attributes.put("name", getName());
		attributes.put("mimeType", getMimeType());
		attributes.put("blobData", getBlobData());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long blobId = (Long)attributes.get("blobId");

		if (blobId != null) {
			setBlobId(blobId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String mimeType = (String)attributes.get("mimeType");

		if (mimeType != null) {
			setMimeType(mimeType);
		}

		Blob blobData = (Blob)attributes.get("blobData");

		if (blobData != null) {
			setBlobData(blobData);
		}
	}

	@Override
	public long getBlobId() {
		return _blobId;
	}

	@Override
	public void setBlobId(long blobId) {
		_blobId = blobId;

		if (_blobDemoRemoteModel != null) {
			try {
				Class<?> clazz = _blobDemoRemoteModel.getClass();

				Method method = clazz.getMethod("setBlobId", long.class);

				method.invoke(_blobDemoRemoteModel, blobId);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getName() {
		return _name;
	}

	@Override
	public void setName(String name) {
		_name = name;

		if (_blobDemoRemoteModel != null) {
			try {
				Class<?> clazz = _blobDemoRemoteModel.getClass();

				Method method = clazz.getMethod("setName", String.class);

				method.invoke(_blobDemoRemoteModel, name);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getMimeType() {
		return _mimeType;
	}

	@Override
	public void setMimeType(String mimeType) {
		_mimeType = mimeType;

		if (_blobDemoRemoteModel != null) {
			try {
				Class<?> clazz = _blobDemoRemoteModel.getClass();

				Method method = clazz.getMethod("setMimeType", String.class);

				method.invoke(_blobDemoRemoteModel, mimeType);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public Blob getBlobData() {
		return _blobData;
	}

	@Override
	public void setBlobData(Blob blobData) {
		_blobData = blobData;

		if (_blobDemoRemoteModel != null) {
			try {
				Class<?> clazz = _blobDemoRemoteModel.getClass();

				Method method = clazz.getMethod("setBlobData", Blob.class);

				method.invoke(_blobDemoRemoteModel, blobData);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	public BaseModel<?> getBlobDemoRemoteModel() {
		return _blobDemoRemoteModel;
	}

	public void setBlobDemoRemoteModel(BaseModel<?> blobDemoRemoteModel) {
		_blobDemoRemoteModel = blobDemoRemoteModel;
	}

	public Object invokeOnRemoteModel(String methodName,
		Class<?>[] parameterTypes, Object[] parameterValues)
		throws Exception {
		Object[] remoteParameterValues = new Object[parameterValues.length];

		for (int i = 0; i < parameterValues.length; i++) {
			if (parameterValues[i] != null) {
				remoteParameterValues[i] = ClpSerializer.translateInput(parameterValues[i]);
			}
		}

		Class<?> remoteModelClass = _blobDemoRemoteModel.getClass();

		ClassLoader remoteModelClassLoader = remoteModelClass.getClassLoader();

		Class<?>[] remoteParameterTypes = new Class[parameterTypes.length];

		for (int i = 0; i < parameterTypes.length; i++) {
			if (parameterTypes[i].isPrimitive()) {
				remoteParameterTypes[i] = parameterTypes[i];
			}
			else {
				String parameterTypeName = parameterTypes[i].getName();

				remoteParameterTypes[i] = remoteModelClassLoader.loadClass(parameterTypeName);
			}
		}

		Method method = remoteModelClass.getMethod(methodName,
				remoteParameterTypes);

		Object returnValue = method.invoke(_blobDemoRemoteModel,
				remoteParameterValues);

		if (returnValue != null) {
			returnValue = ClpSerializer.translateOutput(returnValue);
		}

		return returnValue;
	}

	@Override
	public void persist() throws SystemException {
		if (this.isNew()) {
			BlobDemoLocalServiceUtil.addBlobDemo(this);
		}
		else {
			BlobDemoLocalServiceUtil.updateBlobDemo(this);
		}
	}

	@Override
	public BlobDemo toEscapedModel() {
		return (BlobDemo)ProxyUtil.newProxyInstance(BlobDemo.class.getClassLoader(),
			new Class[] { BlobDemo.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		BlobDemoClp clone = new BlobDemoClp();

		clone.setBlobId(getBlobId());
		clone.setName(getName());
		clone.setMimeType(getMimeType());
		clone.setBlobData(getBlobData());

		return clone;
	}

	@Override
	public int compareTo(BlobDemo blobDemo) {
		long primaryKey = blobDemo.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof BlobDemoClp)) {
			return false;
		}

		BlobDemoClp blobDemo = (BlobDemoClp)obj;

		long primaryKey = blobDemo.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(9);

		sb.append("{blobId=");
		sb.append(getBlobId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", mimeType=");
		sb.append(getMimeType());
		sb.append(", blobData=");
		sb.append(getBlobData());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(16);

		sb.append("<model><model-name>");
		sb.append("com.proliferay.servicebuilder.model.BlobDemo");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>blobId</column-name><column-value><![CDATA[");
		sb.append(getBlobId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>mimeType</column-name><column-value><![CDATA[");
		sb.append(getMimeType());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>blobData</column-name><column-value><![CDATA[");
		sb.append(getBlobData());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _blobId;
	private String _name;
	private String _mimeType;
	private Blob _blobData;
	private BaseModel<?> _blobDemoRemoteModel;
}