/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.sql.Blob;

/**
 * The base model interface for the BlobDemo service. Represents a row in the &quot;PROLIFERAY_BlobDemo&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.proliferay.servicebuilder.model.impl.BlobDemoImpl}.
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemo
 * @see com.proliferay.servicebuilder.model.impl.BlobDemoImpl
 * @see com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl
 * @generated
 */
public interface BlobDemoModel extends BaseModel<BlobDemo> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a blob demo model instance should use the {@link BlobDemo} interface instead.
	 */

	/**
	 * Returns the primary key of this blob demo.
	 *
	 * @return the primary key of this blob demo
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this blob demo.
	 *
	 * @param primaryKey the primary key of this blob demo
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the blob ID of this blob demo.
	 *
	 * @return the blob ID of this blob demo
	 */
	public long getBlobId();

	/**
	 * Sets the blob ID of this blob demo.
	 *
	 * @param blobId the blob ID of this blob demo
	 */
	public void setBlobId(long blobId);

	/**
	 * Returns the name of this blob demo.
	 *
	 * @return the name of this blob demo
	 */
	@AutoEscape
	public String getName();

	/**
	 * Sets the name of this blob demo.
	 *
	 * @param name the name of this blob demo
	 */
	public void setName(String name);

	/**
	 * Returns the mime type of this blob demo.
	 *
	 * @return the mime type of this blob demo
	 */
	@AutoEscape
	public String getMimeType();

	/**
	 * Sets the mime type of this blob demo.
	 *
	 * @param mimeType the mime type of this blob demo
	 */
	public void setMimeType(String mimeType);

	/**
	 * Returns the blob data of this blob demo.
	 *
	 * @return the blob data of this blob demo
	 */
	public Blob getBlobData();

	/**
	 * Sets the blob data of this blob demo.
	 *
	 * @param blobData the blob data of this blob demo
	 */
	public void setBlobData(Blob blobData);

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(BlobDemo blobDemo);

	@Override
	public int hashCode();

	@Override
	public CacheModel<BlobDemo> toCacheModel();

	@Override
	public BlobDemo toEscapedModel();

	@Override
	public BlobDemo toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();
}