/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model;

import java.io.Serializable;

import java.sql.Blob;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.proliferay.servicebuilder.service.http.BlobDemoServiceSoap}.
 *
 * @author Hamidul Islam
 * @see com.proliferay.servicebuilder.service.http.BlobDemoServiceSoap
 * @generated
 */
public class BlobDemoSoap implements Serializable {
	public static BlobDemoSoap toSoapModel(BlobDemo model) {
		BlobDemoSoap soapModel = new BlobDemoSoap();

		soapModel.setBlobId(model.getBlobId());
		soapModel.setName(model.getName());
		soapModel.setMimeType(model.getMimeType());
		soapModel.setBlobData(model.getBlobData());

		return soapModel;
	}

	public static BlobDemoSoap[] toSoapModels(BlobDemo[] models) {
		BlobDemoSoap[] soapModels = new BlobDemoSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static BlobDemoSoap[][] toSoapModels(BlobDemo[][] models) {
		BlobDemoSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new BlobDemoSoap[models.length][models[0].length];
		}
		else {
			soapModels = new BlobDemoSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static BlobDemoSoap[] toSoapModels(List<BlobDemo> models) {
		List<BlobDemoSoap> soapModels = new ArrayList<BlobDemoSoap>(models.size());

		for (BlobDemo model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new BlobDemoSoap[soapModels.size()]);
	}

	public BlobDemoSoap() {
	}

	public long getPrimaryKey() {
		return _blobId;
	}

	public void setPrimaryKey(long pk) {
		setBlobId(pk);
	}

	public long getBlobId() {
		return _blobId;
	}

	public void setBlobId(long blobId) {
		_blobId = blobId;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public String getMimeType() {
		return _mimeType;
	}

	public void setMimeType(String mimeType) {
		_mimeType = mimeType;
	}

	public Blob getBlobData() {
		return _blobData;
	}

	public void setBlobData(Blob blobData) {
		_blobData = blobData;
	}

	private long _blobId;
	private String _name;
	private String _mimeType;
	private Blob _blobData;
}