/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model;

import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.ModelWrapper;

import java.sql.Blob;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link BlobDemo}.
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemo
 * @generated
 */
public class BlobDemoWrapper implements BlobDemo, ModelWrapper<BlobDemo> {
	public BlobDemoWrapper(BlobDemo blobDemo) {
		_blobDemo = blobDemo;
	}

	@Override
	public Class<?> getModelClass() {
		return BlobDemo.class;
	}

	@Override
	public String getModelClassName() {
		return BlobDemo.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("blobId", getBlobId());
		attributes.put("name", getName());
		attributes.put("mimeType", getMimeType());
		attributes.put("blobData", getBlobData());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long blobId = (Long)attributes.get("blobId");

		if (blobId != null) {
			setBlobId(blobId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String mimeType = (String)attributes.get("mimeType");

		if (mimeType != null) {
			setMimeType(mimeType);
		}

		Blob blobData = (Blob)attributes.get("blobData");

		if (blobData != null) {
			setBlobData(blobData);
		}
	}

	/**
	* Returns the primary key of this blob demo.
	*
	* @return the primary key of this blob demo
	*/
	@Override
	public long getPrimaryKey() {
		return _blobDemo.getPrimaryKey();
	}

	/**
	* Sets the primary key of this blob demo.
	*
	* @param primaryKey the primary key of this blob demo
	*/
	@Override
	public void setPrimaryKey(long primaryKey) {
		_blobDemo.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the blob ID of this blob demo.
	*
	* @return the blob ID of this blob demo
	*/
	@Override
	public long getBlobId() {
		return _blobDemo.getBlobId();
	}

	/**
	* Sets the blob ID of this blob demo.
	*
	* @param blobId the blob ID of this blob demo
	*/
	@Override
	public void setBlobId(long blobId) {
		_blobDemo.setBlobId(blobId);
	}

	/**
	* Returns the name of this blob demo.
	*
	* @return the name of this blob demo
	*/
	@Override
	public java.lang.String getName() {
		return _blobDemo.getName();
	}

	/**
	* Sets the name of this blob demo.
	*
	* @param name the name of this blob demo
	*/
	@Override
	public void setName(java.lang.String name) {
		_blobDemo.setName(name);
	}

	/**
	* Returns the mime type of this blob demo.
	*
	* @return the mime type of this blob demo
	*/
	@Override
	public java.lang.String getMimeType() {
		return _blobDemo.getMimeType();
	}

	/**
	* Sets the mime type of this blob demo.
	*
	* @param mimeType the mime type of this blob demo
	*/
	@Override
	public void setMimeType(java.lang.String mimeType) {
		_blobDemo.setMimeType(mimeType);
	}

	/**
	* Returns the blob data of this blob demo.
	*
	* @return the blob data of this blob demo
	*/
	@Override
	public java.sql.Blob getBlobData() {
		return _blobDemo.getBlobData();
	}

	/**
	* Sets the blob data of this blob demo.
	*
	* @param blobData the blob data of this blob demo
	*/
	@Override
	public void setBlobData(java.sql.Blob blobData) {
		_blobDemo.setBlobData(blobData);
	}

	@Override
	public boolean isNew() {
		return _blobDemo.isNew();
	}

	@Override
	public void setNew(boolean n) {
		_blobDemo.setNew(n);
	}

	@Override
	public boolean isCachedModel() {
		return _blobDemo.isCachedModel();
	}

	@Override
	public void setCachedModel(boolean cachedModel) {
		_blobDemo.setCachedModel(cachedModel);
	}

	@Override
	public boolean isEscapedModel() {
		return _blobDemo.isEscapedModel();
	}

	@Override
	public java.io.Serializable getPrimaryKeyObj() {
		return _blobDemo.getPrimaryKeyObj();
	}

	@Override
	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_blobDemo.setPrimaryKeyObj(primaryKeyObj);
	}

	@Override
	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _blobDemo.getExpandoBridge();
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.model.BaseModel<?> baseModel) {
		_blobDemo.setExpandoBridgeAttributes(baseModel);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portlet.expando.model.ExpandoBridge expandoBridge) {
		_blobDemo.setExpandoBridgeAttributes(expandoBridge);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_blobDemo.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new BlobDemoWrapper((BlobDemo)_blobDemo.clone());
	}

	@Override
	public int compareTo(com.proliferay.servicebuilder.model.BlobDemo blobDemo) {
		return _blobDemo.compareTo(blobDemo);
	}

	@Override
	public int hashCode() {
		return _blobDemo.hashCode();
	}

	@Override
	public com.liferay.portal.model.CacheModel<com.proliferay.servicebuilder.model.BlobDemo> toCacheModel() {
		return _blobDemo.toCacheModel();
	}

	@Override
	public com.proliferay.servicebuilder.model.BlobDemo toEscapedModel() {
		return new BlobDemoWrapper(_blobDemo.toEscapedModel());
	}

	@Override
	public com.proliferay.servicebuilder.model.BlobDemo toUnescapedModel() {
		return new BlobDemoWrapper(_blobDemo.toUnescapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _blobDemo.toString();
	}

	@Override
	public java.lang.String toXmlString() {
		return _blobDemo.toXmlString();
	}

	@Override
	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_blobDemo.persist();
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof BlobDemoWrapper)) {
			return false;
		}

		BlobDemoWrapper blobDemoWrapper = (BlobDemoWrapper)obj;

		if (Validator.equals(_blobDemo, blobDemoWrapper._blobDemo)) {
			return true;
		}

		return false;
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #getWrappedModel}
	 */
	public BlobDemo getWrappedBlobDemo() {
		return _blobDemo;
	}

	@Override
	public BlobDemo getWrappedModel() {
		return _blobDemo;
	}

	@Override
	public void resetOriginalValues() {
		_blobDemo.resetOriginalValues();
	}

	private BlobDemo _blobDemo;
}