/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link BlobDemoLocalService}.
 *
 * @author Hamidul Islam
 * @see BlobDemoLocalService
 * @generated
 */
public class BlobDemoLocalServiceWrapper implements BlobDemoLocalService,
	ServiceWrapper<BlobDemoLocalService> {
	public BlobDemoLocalServiceWrapper(
		BlobDemoLocalService blobDemoLocalService) {
		_blobDemoLocalService = blobDemoLocalService;
	}

	/**
	* Adds the blob demo to the database. Also notifies the appropriate model listeners.
	*
	* @param blobDemo the blob demo
	* @return the blob demo that was added
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo addBlobDemo(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.addBlobDemo(blobDemo);
	}

	/**
	* Creates a new blob demo with the primary key. Does not add the blob demo to the database.
	*
	* @param blobId the primary key for the new blob demo
	* @return the new blob demo
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo createBlobDemo(
		long blobId) {
		return _blobDemoLocalService.createBlobDemo(blobId);
	}

	/**
	* Deletes the blob demo with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo that was removed
	* @throws PortalException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo deleteBlobDemo(
		long blobId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.deleteBlobDemo(blobId);
	}

	/**
	* Deletes the blob demo from the database. Also notifies the appropriate model listeners.
	*
	* @param blobDemo the blob demo
	* @return the blob demo that was removed
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo deleteBlobDemo(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.deleteBlobDemo(blobDemo);
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return _blobDemoLocalService.dynamicQuery();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@Override
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@Override
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@Override
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.dynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.dynamicQueryCount(dynamicQuery, projection);
	}

	@Override
	public com.proliferay.servicebuilder.model.BlobDemo fetchBlobDemo(
		long blobId) throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.fetchBlobDemo(blobId);
	}

	/**
	* Returns the blob demo with the primary key.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo
	* @throws PortalException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo getBlobDemo(long blobId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.getBlobDemo(blobId);
	}

	@Override
	public com.liferay.portal.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.getPersistedModel(primaryKeyObj);
	}

	/**
	* Returns a range of all the blob demos.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of blob demos
	* @param end the upper bound of the range of blob demos (not inclusive)
	* @return the range of blob demos
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public java.util.List<com.proliferay.servicebuilder.model.BlobDemo> getBlobDemos(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.getBlobDemos(start, end);
	}

	/**
	* Returns the number of blob demos.
	*
	* @return the number of blob demos
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public int getBlobDemosCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.getBlobDemosCount();
	}

	/**
	* Updates the blob demo in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param blobDemo the blob demo
	* @return the blob demo that was updated
	* @throws SystemException if a system exception occurred
	*/
	@Override
	public com.proliferay.servicebuilder.model.BlobDemo updateBlobDemo(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.updateBlobDemo(blobDemo);
	}

	@Override
	public com.proliferay.servicebuilder.model.BlobDemoBlobDataBlobModel getBlobDataBlobModel(
		java.io.Serializable primaryKey)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _blobDemoLocalService.getBlobDataBlobModel(primaryKey);
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	@Override
	public java.lang.String getBeanIdentifier() {
		return _blobDemoLocalService.getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	@Override
	public void setBeanIdentifier(java.lang.String beanIdentifier) {
		_blobDemoLocalService.setBeanIdentifier(beanIdentifier);
	}

	@Override
	public java.lang.Object invokeMethod(java.lang.String name,
		java.lang.String[] parameterTypes, java.lang.Object[] arguments)
		throws java.lang.Throwable {
		return _blobDemoLocalService.invokeMethod(name, parameterTypes,
			arguments);
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
	 */
	public BlobDemoLocalService getWrappedBlobDemoLocalService() {
		return _blobDemoLocalService;
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
	 */
	public void setWrappedBlobDemoLocalService(
		BlobDemoLocalService blobDemoLocalService) {
		_blobDemoLocalService = blobDemoLocalService;
	}

	@Override
	public BlobDemoLocalService getWrappedService() {
		return _blobDemoLocalService;
	}

	@Override
	public void setWrappedService(BlobDemoLocalService blobDemoLocalService) {
		_blobDemoLocalService = blobDemoLocalService;
	}

	private BlobDemoLocalService _blobDemoLocalService;
}