/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.service.persistence;

import com.liferay.portal.service.persistence.BasePersistence;

import com.proliferay.servicebuilder.model.BlobDemo;

/**
 * The persistence interface for the blob demo service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemoPersistenceImpl
 * @see BlobDemoUtil
 * @generated
 */
public interface BlobDemoPersistence extends BasePersistence<BlobDemo> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. Always use {@link BlobDemoUtil} to access the blob demo persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
	 */

	/**
	* Caches the blob demo in the entity cache if it is enabled.
	*
	* @param blobDemo the blob demo
	*/
	public void cacheResult(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo);

	/**
	* Caches the blob demos in the entity cache if it is enabled.
	*
	* @param blobDemos the blob demos
	*/
	public void cacheResult(
		java.util.List<com.proliferay.servicebuilder.model.BlobDemo> blobDemos);

	/**
	* Creates a new blob demo with the primary key. Does not add the blob demo to the database.
	*
	* @param blobId the primary key for the new blob demo
	* @return the new blob demo
	*/
	public com.proliferay.servicebuilder.model.BlobDemo create(long blobId);

	/**
	* Removes the blob demo with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo that was removed
	* @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.proliferay.servicebuilder.model.BlobDemo remove(long blobId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.proliferay.servicebuilder.NoSuchBlobDemoException;

	public com.proliferay.servicebuilder.model.BlobDemo updateImpl(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the blob demo with the primary key or throws a {@link com.proliferay.servicebuilder.NoSuchBlobDemoException} if it could not be found.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo
	* @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.proliferay.servicebuilder.model.BlobDemo findByPrimaryKey(
		long blobId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.proliferay.servicebuilder.NoSuchBlobDemoException;

	/**
	* Returns the blob demo with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo, or <code>null</code> if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.proliferay.servicebuilder.model.BlobDemo fetchByPrimaryKey(
		long blobId) throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns all the blob demos.
	*
	* @return the blob demos
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the blob demos.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of blob demos
	* @param end the upper bound of the range of blob demos (not inclusive)
	* @return the range of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the blob demos.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of blob demos
	* @param end the upper bound of the range of blob demos (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll(
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes all the blob demos from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of blob demos.
	*
	* @return the number of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public int countAll()
		throws com.liferay.portal.kernel.exception.SystemException;
}