/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.ServiceContext;

import com.proliferay.servicebuilder.model.BlobDemo;

import java.util.List;

/**
 * The persistence utility for the blob demo service. This utility wraps {@link BlobDemoPersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemoPersistence
 * @see BlobDemoPersistenceImpl
 * @generated
 */
public class BlobDemoUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache()
	 */
	public static void clearCache() {
		getPersistence().clearCache();
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache(com.liferay.portal.model.BaseModel)
	 */
	public static void clearCache(BlobDemo blobDemo) {
		getPersistence().clearCache(blobDemo);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
	 */
	public static long countWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
	 */
	public static List<BlobDemo> findWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
	 */
	public static List<BlobDemo> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
	 */
	public static List<BlobDemo> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return getPersistence()
				   .findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel)
	 */
	public static BlobDemo update(BlobDemo blobDemo) throws SystemException {
		return getPersistence().update(blobDemo);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, ServiceContext)
	 */
	public static BlobDemo update(BlobDemo blobDemo,
		ServiceContext serviceContext) throws SystemException {
		return getPersistence().update(blobDemo, serviceContext);
	}

	/**
	* Caches the blob demo in the entity cache if it is enabled.
	*
	* @param blobDemo the blob demo
	*/
	public static void cacheResult(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo) {
		getPersistence().cacheResult(blobDemo);
	}

	/**
	* Caches the blob demos in the entity cache if it is enabled.
	*
	* @param blobDemos the blob demos
	*/
	public static void cacheResult(
		java.util.List<com.proliferay.servicebuilder.model.BlobDemo> blobDemos) {
		getPersistence().cacheResult(blobDemos);
	}

	/**
	* Creates a new blob demo with the primary key. Does not add the blob demo to the database.
	*
	* @param blobId the primary key for the new blob demo
	* @return the new blob demo
	*/
	public static com.proliferay.servicebuilder.model.BlobDemo create(
		long blobId) {
		return getPersistence().create(blobId);
	}

	/**
	* Removes the blob demo with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo that was removed
	* @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.proliferay.servicebuilder.model.BlobDemo remove(
		long blobId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.proliferay.servicebuilder.NoSuchBlobDemoException {
		return getPersistence().remove(blobId);
	}

	public static com.proliferay.servicebuilder.model.BlobDemo updateImpl(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().updateImpl(blobDemo);
	}

	/**
	* Returns the blob demo with the primary key or throws a {@link com.proliferay.servicebuilder.NoSuchBlobDemoException} if it could not be found.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo
	* @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.proliferay.servicebuilder.model.BlobDemo findByPrimaryKey(
		long blobId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.proliferay.servicebuilder.NoSuchBlobDemoException {
		return getPersistence().findByPrimaryKey(blobId);
	}

	/**
	* Returns the blob demo with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param blobId the primary key of the blob demo
	* @return the blob demo, or <code>null</code> if a blob demo with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.proliferay.servicebuilder.model.BlobDemo fetchByPrimaryKey(
		long blobId) throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByPrimaryKey(blobId);
	}

	/**
	* Returns all the blob demos.
	*
	* @return the blob demos
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll();
	}

	/**
	* Returns a range of all the blob demos.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of blob demos
	* @param end the upper bound of the range of blob demos (not inclusive)
	* @return the range of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end);
	}

	/**
	* Returns an ordered range of all the blob demos.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of blob demos
	* @param end the upper bound of the range of blob demos (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.proliferay.servicebuilder.model.BlobDemo> findAll(
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end, orderByComparator);
	}

	/**
	* Removes all the blob demos from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public static void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeAll();
	}

	/**
	* Returns the number of blob demos.
	*
	* @return the number of blob demos
	* @throws SystemException if a system exception occurred
	*/
	public static int countAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countAll();
	}

	public static BlobDemoPersistence getPersistence() {
		if (_persistence == null) {
			_persistence = (BlobDemoPersistence)PortletBeanLocatorUtil.locate(com.proliferay.servicebuilder.service.ClpSerializer.getServletContextName(),
					BlobDemoPersistence.class.getName());

			ReferenceRegistry.registerReference(BlobDemoUtil.class,
				"_persistence");
		}

		return _persistence;
	}

	/**
	 * @deprecated As of 6.2.0
	 */
	public void setPersistence(BlobDemoPersistence persistence) {
	}

	private static BlobDemoPersistence _persistence;
}