/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.proliferay.servicebuilder.model.BlobDemo;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

/**
 * The cache model class for representing BlobDemo in entity cache.
 *
 * @author Hamidul Islam
 * @see BlobDemo
 * @generated
 */
public class BlobDemoCacheModel implements CacheModel<BlobDemo>, Externalizable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(7);

		sb.append("{blobId=");
		sb.append(blobId);
		sb.append(", name=");
		sb.append(name);
		sb.append(", mimeType=");
		sb.append(mimeType);

		return sb.toString();
	}

	@Override
	public BlobDemo toEntityModel() {
		BlobDemoImpl blobDemoImpl = new BlobDemoImpl();

		blobDemoImpl.setBlobId(blobId);

		if (name == null) {
			blobDemoImpl.setName(StringPool.BLANK);
		}
		else {
			blobDemoImpl.setName(name);
		}

		if (mimeType == null) {
			blobDemoImpl.setMimeType(StringPool.BLANK);
		}
		else {
			blobDemoImpl.setMimeType(mimeType);
		}

		blobDemoImpl.resetOriginalValues();

		return blobDemoImpl;
	}

	@Override
	public void readExternal(ObjectInput objectInput) throws IOException {
		blobId = objectInput.readLong();
		name = objectInput.readUTF();
		mimeType = objectInput.readUTF();
	}

	@Override
	public void writeExternal(ObjectOutput objectOutput)
		throws IOException {
		objectOutput.writeLong(blobId);

		if (name == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(name);
		}

		if (mimeType == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(mimeType);
		}
	}

	public long blobId;
	public String name;
	public String mimeType;
}