/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import com.proliferay.servicebuilder.model.BlobDemo;
import com.proliferay.servicebuilder.model.BlobDemoBlobDataBlobModel;
import com.proliferay.servicebuilder.model.BlobDemoModel;
import com.proliferay.servicebuilder.model.BlobDemoSoap;
import com.proliferay.servicebuilder.service.BlobDemoLocalServiceUtil;

import java.io.Serializable;

import java.sql.Blob;
import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the BlobDemo service. Represents a row in the &quot;PROLIFERAY_BlobDemo&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.proliferay.servicebuilder.model.BlobDemoModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BlobDemoImpl}.
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemoImpl
 * @see com.proliferay.servicebuilder.model.BlobDemo
 * @see com.proliferay.servicebuilder.model.BlobDemoModel
 * @generated
 */
@JSON(strict = true)
public class BlobDemoModelImpl extends BaseModelImpl<BlobDemo>
	implements BlobDemoModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a blob demo model instance should use the {@link com.proliferay.servicebuilder.model.BlobDemo} interface instead.
	 */
	public static final String TABLE_NAME = "PROLIFERAY_BlobDemo";
	public static final Object[][] TABLE_COLUMNS = {
			{ "blobId", Types.BIGINT },
			{ "name", Types.VARCHAR },
			{ "mimeType", Types.VARCHAR },
			{ "blobData", Types.BLOB }
		};
	public static final String TABLE_SQL_CREATE = "create table PROLIFERAY_BlobDemo (blobId LONG not null primary key,name VARCHAR(75) null,mimeType VARCHAR(75) null,blobData BLOB)";
	public static final String TABLE_SQL_DROP = "drop table PROLIFERAY_BlobDemo";
	public static final String ORDER_BY_JPQL = " ORDER BY blobDemo.blobId ASC";
	public static final String ORDER_BY_SQL = " ORDER BY PROLIFERAY_BlobDemo.blobId ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.proliferay.servicebuilder.model.BlobDemo"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.proliferay.servicebuilder.model.BlobDemo"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = false;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static BlobDemo toModel(BlobDemoSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		BlobDemo model = new BlobDemoImpl();

		model.setBlobId(soapModel.getBlobId());
		model.setName(soapModel.getName());
		model.setMimeType(soapModel.getMimeType());
		model.setBlobData(soapModel.getBlobData());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<BlobDemo> toModels(BlobDemoSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<BlobDemo> models = new ArrayList<BlobDemo>(soapModels.length);

		for (BlobDemoSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.proliferay.servicebuilder.model.BlobDemo"));

	public BlobDemoModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _blobId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setBlobId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _blobId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return BlobDemo.class;
	}

	@Override
	public String getModelClassName() {
		return BlobDemo.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("blobId", getBlobId());
		attributes.put("name", getName());
		attributes.put("mimeType", getMimeType());
		attributes.put("blobData", getBlobData());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long blobId = (Long)attributes.get("blobId");

		if (blobId != null) {
			setBlobId(blobId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String mimeType = (String)attributes.get("mimeType");

		if (mimeType != null) {
			setMimeType(mimeType);
		}

		Blob blobData = (Blob)attributes.get("blobData");

		if (blobData != null) {
			setBlobData(blobData);
		}
	}

	@JSON
	@Override
	public long getBlobId() {
		return _blobId;
	}

	@Override
	public void setBlobId(long blobId) {
		_blobId = blobId;
	}

	@JSON
	@Override
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	@Override
	public void setName(String name) {
		_name = name;
	}

	@JSON
	@Override
	public String getMimeType() {
		if (_mimeType == null) {
			return StringPool.BLANK;
		}
		else {
			return _mimeType;
		}
	}

	@Override
	public void setMimeType(String mimeType) {
		_mimeType = mimeType;
	}

	@JSON
	@Override
	public Blob getBlobData() {
		if (_blobDataBlobModel == null) {
			try {
				_blobDataBlobModel = BlobDemoLocalServiceUtil.getBlobDataBlobModel(getPrimaryKey());
			}
			catch (Exception e) {
			}
		}

		Blob blob = null;

		if (_blobDataBlobModel != null) {
			blob = _blobDataBlobModel.getBlobDataBlob();
		}

		return blob;
	}

	@Override
	public void setBlobData(Blob blobData) {
		if (_blobDataBlobModel == null) {
			_blobDataBlobModel = new BlobDemoBlobDataBlobModel(getPrimaryKey(),
					blobData);
		}
		else {
			_blobDataBlobModel.setBlobDataBlob(blobData);
		}
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
			BlobDemo.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public BlobDemo toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = (BlobDemo)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelInterfaces, new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		BlobDemoImpl blobDemoImpl = new BlobDemoImpl();

		blobDemoImpl.setBlobId(getBlobId());
		blobDemoImpl.setName(getName());
		blobDemoImpl.setMimeType(getMimeType());

		blobDemoImpl.resetOriginalValues();

		return blobDemoImpl;
	}

	@Override
	public int compareTo(BlobDemo blobDemo) {
		long primaryKey = blobDemo.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof BlobDemo)) {
			return false;
		}

		BlobDemo blobDemo = (BlobDemo)obj;

		long primaryKey = blobDemo.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		BlobDemoModelImpl blobDemoModelImpl = this;

		blobDemoModelImpl._blobDataBlobModel = null;
	}

	@Override
	public CacheModel<BlobDemo> toCacheModel() {
		BlobDemoCacheModel blobDemoCacheModel = new BlobDemoCacheModel();

		blobDemoCacheModel.blobId = getBlobId();

		blobDemoCacheModel.name = getName();

		String name = blobDemoCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			blobDemoCacheModel.name = null;
		}

		blobDemoCacheModel.mimeType = getMimeType();

		String mimeType = blobDemoCacheModel.mimeType;

		if ((mimeType != null) && (mimeType.length() == 0)) {
			blobDemoCacheModel.mimeType = null;
		}

		return blobDemoCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(9);

		sb.append("{blobId=");
		sb.append(getBlobId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", mimeType=");
		sb.append(getMimeType());

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(16);

		sb.append("<model><model-name>");
		sb.append("com.proliferay.servicebuilder.model.BlobDemo");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>blobId</column-name><column-value><![CDATA[");
		sb.append(getBlobId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>mimeType</column-name><column-value><![CDATA[");
		sb.append(getMimeType());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = BlobDemo.class.getClassLoader();
	private static Class<?>[] _escapedModelInterfaces = new Class[] {
			BlobDemo.class
		};
	private long _blobId;
	private String _name;
	private String _mimeType;
	private BlobDemoBlobDataBlobModel _blobDataBlobModel;
	private BlobDemo _escapedModel;
}