/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.service.base;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.service.BaseServiceImpl;
import com.liferay.portal.service.persistence.UserPersistence;

import com.proliferay.servicebuilder.model.BlobDemo;
import com.proliferay.servicebuilder.service.BlobDemoService;
import com.proliferay.servicebuilder.service.persistence.BlobDemoPersistence;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the blob demo remote service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link com.proliferay.servicebuilder.service.impl.BlobDemoServiceImpl}.
 * </p>
 *
 * @author Hamidul Islam
 * @see com.proliferay.servicebuilder.service.impl.BlobDemoServiceImpl
 * @see com.proliferay.servicebuilder.service.BlobDemoServiceUtil
 * @generated
 */
public abstract class BlobDemoServiceBaseImpl extends BaseServiceImpl
	implements BlobDemoService, IdentifiableBean {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link com.proliferay.servicebuilder.service.BlobDemoServiceUtil} to access the blob demo remote service.
	 */

	/**
	 * Returns the blob demo local service.
	 *
	 * @return the blob demo local service
	 */
	public com.proliferay.servicebuilder.service.BlobDemoLocalService getBlobDemoLocalService() {
		return blobDemoLocalService;
	}

	/**
	 * Sets the blob demo local service.
	 *
	 * @param blobDemoLocalService the blob demo local service
	 */
	public void setBlobDemoLocalService(
		com.proliferay.servicebuilder.service.BlobDemoLocalService blobDemoLocalService) {
		this.blobDemoLocalService = blobDemoLocalService;
	}

	/**
	 * Returns the blob demo remote service.
	 *
	 * @return the blob demo remote service
	 */
	public com.proliferay.servicebuilder.service.BlobDemoService getBlobDemoService() {
		return blobDemoService;
	}

	/**
	 * Sets the blob demo remote service.
	 *
	 * @param blobDemoService the blob demo remote service
	 */
	public void setBlobDemoService(
		com.proliferay.servicebuilder.service.BlobDemoService blobDemoService) {
		this.blobDemoService = blobDemoService;
	}

	/**
	 * Returns the blob demo persistence.
	 *
	 * @return the blob demo persistence
	 */
	public BlobDemoPersistence getBlobDemoPersistence() {
		return blobDemoPersistence;
	}

	/**
	 * Sets the blob demo persistence.
	 *
	 * @param blobDemoPersistence the blob demo persistence
	 */
	public void setBlobDemoPersistence(BlobDemoPersistence blobDemoPersistence) {
		this.blobDemoPersistence = blobDemoPersistence;
	}

	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public com.liferay.counter.service.CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(
		com.liferay.counter.service.CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public com.liferay.portal.service.ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		com.liferay.portal.service.ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public com.liferay.portal.service.UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(
		com.liferay.portal.service.UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Returns the user remote service.
	 *
	 * @return the user remote service
	 */
	public com.liferay.portal.service.UserService getUserService() {
		return userService;
	}

	/**
	 * Sets the user remote service.
	 *
	 * @param userService the user remote service
	 */
	public void setUserService(
		com.liferay.portal.service.UserService userService) {
		this.userService = userService;
	}

	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	public void afterPropertiesSet() {
		Class<?> clazz = getClass();

		_classLoader = clazz.getClassLoader();
	}

	public void destroy() {
	}

	/**
	 * Returns the Spring bean ID for this bean.
	 *
	 * @return the Spring bean ID for this bean
	 */
	@Override
	public String getBeanIdentifier() {
		return _beanIdentifier;
	}

	/**
	 * Sets the Spring bean ID for this bean.
	 *
	 * @param beanIdentifier the Spring bean ID for this bean
	 */
	@Override
	public void setBeanIdentifier(String beanIdentifier) {
		_beanIdentifier = beanIdentifier;
	}

	@Override
	public Object invokeMethod(String name, String[] parameterTypes,
		Object[] arguments) throws Throwable {
		Thread currentThread = Thread.currentThread();

		ClassLoader contextClassLoader = currentThread.getContextClassLoader();

		if (contextClassLoader != _classLoader) {
			currentThread.setContextClassLoader(_classLoader);
		}

		try {
			return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
		}
		finally {
			if (contextClassLoader != _classLoader) {
				currentThread.setContextClassLoader(contextClassLoader);
			}
		}
	}

	protected Class<?> getModelClass() {
		return BlobDemo.class;
	}

	protected String getModelClassName() {
		return BlobDemo.class.getName();
	}

	/**
	 * Performs an SQL query.
	 *
	 * @param sql the sql query
	 */
	protected void runSQL(String sql) throws SystemException {
		try {
			DataSource dataSource = blobDemoPersistence.getDataSource();

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql, new int[0]);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = com.proliferay.servicebuilder.service.BlobDemoLocalService.class)
	protected com.proliferay.servicebuilder.service.BlobDemoLocalService blobDemoLocalService;
	@BeanReference(type = com.proliferay.servicebuilder.service.BlobDemoService.class)
	protected com.proliferay.servicebuilder.service.BlobDemoService blobDemoService;
	@BeanReference(type = BlobDemoPersistence.class)
	protected BlobDemoPersistence blobDemoPersistence;
	@BeanReference(type = com.liferay.counter.service.CounterLocalService.class)
	protected com.liferay.counter.service.CounterLocalService counterLocalService;
	@BeanReference(type = com.liferay.portal.service.ResourceLocalService.class)
	protected com.liferay.portal.service.ResourceLocalService resourceLocalService;
	@BeanReference(type = com.liferay.portal.service.UserLocalService.class)
	protected com.liferay.portal.service.UserLocalService userLocalService;
	@BeanReference(type = com.liferay.portal.service.UserService.class)
	protected com.liferay.portal.service.UserService userService;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private String _beanIdentifier;
	private ClassLoader _classLoader;
	private BlobDemoServiceClpInvoker _clpInvoker = new BlobDemoServiceClpInvoker();
}