/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.proliferay.servicebuilder.service.persistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import com.proliferay.servicebuilder.NoSuchBlobDemoException;
import com.proliferay.servicebuilder.model.BlobDemo;
import com.proliferay.servicebuilder.model.impl.BlobDemoImpl;
import com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the blob demo service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hamidul Islam
 * @see BlobDemoPersistence
 * @see BlobDemoUtil
 * @generated
 */
public class BlobDemoPersistenceImpl extends BasePersistenceImpl<BlobDemo>
	implements BlobDemoPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link BlobDemoUtil} to access the blob demo persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = BlobDemoImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoModelImpl.FINDER_CACHE_ENABLED, BlobDemoImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoModelImpl.FINDER_CACHE_ENABLED, BlobDemoImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);

	public BlobDemoPersistenceImpl() {
		setModelClass(BlobDemo.class);
	}

	/**
	 * Caches the blob demo in the entity cache if it is enabled.
	 *
	 * @param blobDemo the blob demo
	 */
	@Override
	public void cacheResult(BlobDemo blobDemo) {
		EntityCacheUtil.putResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoImpl.class, blobDemo.getPrimaryKey(), blobDemo);

		blobDemo.resetOriginalValues();
	}

	/**
	 * Caches the blob demos in the entity cache if it is enabled.
	 *
	 * @param blobDemos the blob demos
	 */
	@Override
	public void cacheResult(List<BlobDemo> blobDemos) {
		for (BlobDemo blobDemo : blobDemos) {
			if (EntityCacheUtil.getResult(
						BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
						BlobDemoImpl.class, blobDemo.getPrimaryKey()) == null) {
				cacheResult(blobDemo);
			}
			else {
				blobDemo.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all blob demos.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(BlobDemoImpl.class.getName());
		}

		EntityCacheUtil.clearCache(BlobDemoImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the blob demo.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(BlobDemo blobDemo) {
		EntityCacheUtil.removeResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoImpl.class, blobDemo.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@Override
	public void clearCache(List<BlobDemo> blobDemos) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (BlobDemo blobDemo : blobDemos) {
			EntityCacheUtil.removeResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
				BlobDemoImpl.class, blobDemo.getPrimaryKey());
		}
	}

	/**
	 * Creates a new blob demo with the primary key. Does not add the blob demo to the database.
	 *
	 * @param blobId the primary key for the new blob demo
	 * @return the new blob demo
	 */
	@Override
	public BlobDemo create(long blobId) {
		BlobDemo blobDemo = new BlobDemoImpl();

		blobDemo.setNew(true);
		blobDemo.setPrimaryKey(blobId);

		return blobDemo;
	}

	/**
	 * Removes the blob demo with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param blobId the primary key of the blob demo
	 * @return the blob demo that was removed
	 * @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo remove(long blobId)
		throws NoSuchBlobDemoException, SystemException {
		return remove((Serializable)blobId);
	}

	/**
	 * Removes the blob demo with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the blob demo
	 * @return the blob demo that was removed
	 * @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo remove(Serializable primaryKey)
		throws NoSuchBlobDemoException, SystemException {
		Session session = null;

		try {
			session = openSession();

			BlobDemo blobDemo = (BlobDemo)session.get(BlobDemoImpl.class,
					primaryKey);

			if (blobDemo == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchBlobDemoException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(blobDemo);
		}
		catch (NoSuchBlobDemoException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected BlobDemo removeImpl(BlobDemo blobDemo) throws SystemException {
		blobDemo = toUnwrappedModel(blobDemo);

		Session session = null;

		try {
			session = openSession();

			if (!session.contains(blobDemo)) {
				blobDemo = (BlobDemo)session.get(BlobDemoImpl.class,
						blobDemo.getPrimaryKeyObj());
			}

			if (blobDemo != null) {
				session.delete(blobDemo);
			}
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		if (blobDemo != null) {
			clearCache(blobDemo);
		}

		return blobDemo;
	}

	@Override
	public BlobDemo updateImpl(
		com.proliferay.servicebuilder.model.BlobDemo blobDemo)
		throws SystemException {
		blobDemo = toUnwrappedModel(blobDemo);

		boolean isNew = blobDemo.isNew();

		Session session = null;

		try {
			session = openSession();

			if (blobDemo.isNew()) {
				session.save(blobDemo);

				blobDemo.setNew(false);
			}
			else {
				session.evict(blobDemo);
				session.saveOrUpdate(blobDemo);
			}

			session.flush();
			session.clear();
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		EntityCacheUtil.putResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
			BlobDemoImpl.class, blobDemo.getPrimaryKey(), blobDemo);

		blobDemo.resetOriginalValues();

		return blobDemo;
	}

	protected BlobDemo toUnwrappedModel(BlobDemo blobDemo) {
		if (blobDemo instanceof BlobDemoImpl) {
			return blobDemo;
		}

		BlobDemoImpl blobDemoImpl = new BlobDemoImpl();

		blobDemoImpl.setNew(blobDemo.isNew());
		blobDemoImpl.setPrimaryKey(blobDemo.getPrimaryKey());

		blobDemoImpl.setBlobId(blobDemo.getBlobId());
		blobDemoImpl.setName(blobDemo.getName());
		blobDemoImpl.setMimeType(blobDemo.getMimeType());
		blobDemoImpl.setBlobData(blobDemo.getBlobData());

		return blobDemoImpl;
	}

	/**
	 * Returns the blob demo with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the blob demo
	 * @return the blob demo
	 * @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo findByPrimaryKey(Serializable primaryKey)
		throws NoSuchBlobDemoException, SystemException {
		BlobDemo blobDemo = fetchByPrimaryKey(primaryKey);

		if (blobDemo == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
			}

			throw new NoSuchBlobDemoException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				primaryKey);
		}

		return blobDemo;
	}

	/**
	 * Returns the blob demo with the primary key or throws a {@link com.proliferay.servicebuilder.NoSuchBlobDemoException} if it could not be found.
	 *
	 * @param blobId the primary key of the blob demo
	 * @return the blob demo
	 * @throws com.proliferay.servicebuilder.NoSuchBlobDemoException if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo findByPrimaryKey(long blobId)
		throws NoSuchBlobDemoException, SystemException {
		return findByPrimaryKey((Serializable)blobId);
	}

	/**
	 * Returns the blob demo with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the blob demo
	 * @return the blob demo, or <code>null</code> if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		BlobDemo blobDemo = (BlobDemo)EntityCacheUtil.getResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
				BlobDemoImpl.class, primaryKey);

		if (blobDemo == _nullBlobDemo) {
			return null;
		}

		if (blobDemo == null) {
			Session session = null;

			try {
				session = openSession();

				blobDemo = (BlobDemo)session.get(BlobDemoImpl.class, primaryKey);

				if (blobDemo != null) {
					cacheResult(blobDemo);
				}
				else {
					EntityCacheUtil.putResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
						BlobDemoImpl.class, primaryKey, _nullBlobDemo);
				}
			}
			catch (Exception e) {
				EntityCacheUtil.removeResult(BlobDemoModelImpl.ENTITY_CACHE_ENABLED,
					BlobDemoImpl.class, primaryKey);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return blobDemo;
	}

	/**
	 * Returns the blob demo with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param blobId the primary key of the blob demo
	 * @return the blob demo, or <code>null</code> if a blob demo with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public BlobDemo fetchByPrimaryKey(long blobId) throws SystemException {
		return fetchByPrimaryKey((Serializable)blobId);
	}

	/**
	 * Returns all the blob demos.
	 *
	 * @return the blob demos
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<BlobDemo> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the blob demos.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of blob demos
	 * @param end the upper bound of the range of blob demos (not inclusive)
	 * @return the range of blob demos
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<BlobDemo> findAll(int start, int end) throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the blob demos.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.proliferay.servicebuilder.model.impl.BlobDemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of blob demos
	 * @param end the upper bound of the range of blob demos (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of blob demos
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<BlobDemo> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<BlobDemo> list = (List<BlobDemo>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_BLOBDEMO);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_BLOBDEMO;

				if (pagination) {
					sql = sql.concat(BlobDemoModelImpl.ORDER_BY_JPQL);
				}
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (!pagination) {
					list = (List<BlobDemo>)QueryUtil.list(q, getDialect(),
							start, end, false);

					Collections.sort(list);

					list = new UnmodifiableList<BlobDemo>(list);
				}
				else {
					list = (List<BlobDemo>)QueryUtil.list(q, getDialect(),
							start, end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the blob demos from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeAll() throws SystemException {
		for (BlobDemo blobDemo : findAll()) {
			remove(blobDemo);
		}
	}

	/**
	 * Returns the number of blob demos.
	 *
	 * @return the number of blob demos
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_BLOBDEMO);

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the blob demo persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.com.proliferay.servicebuilder.model.BlobDemo")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<BlobDemo>> listenersList = new ArrayList<ModelListener<BlobDemo>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<BlobDemo>)InstanceFactory.newInstance(
							getClassLoader(), listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(BlobDemoImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	private static final String _SQL_SELECT_BLOBDEMO = "SELECT blobDemo FROM BlobDemo blobDemo";
	private static final String _SQL_COUNT_BLOBDEMO = "SELECT COUNT(blobDemo) FROM BlobDemo blobDemo";
	private static final String _ORDER_BY_ENTITY_ALIAS = "blobDemo.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No BlobDemo exists with the primary key ";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(BlobDemoPersistenceImpl.class);
	private static BlobDemo _nullBlobDemo = new BlobDemoImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<BlobDemo> toCacheModel() {
				return _nullBlobDemoCacheModel;
			}
		};

	private static CacheModel<BlobDemo> _nullBlobDemoCacheModel = new CacheModel<BlobDemo>() {
			@Override
			public BlobDemo toEntityModel() {
				return _nullBlobDemo;
			}
		};
}